// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _MatrixEntryPtrOSLSet_h
#ifdef __GNUG__
#pragma interface
#endif
#define _MatrixEntryPtrOSLSet_h 1

#include "MatrixEntryPtr.Set.h"
#include "MatrixEntryPtr.SLList.h"

class MatrixEntryPtrOSLSet : public MatrixEntryPtrSet
{
protected:
  MatrixEntryPtrSLList     p;

public:
                MatrixEntryPtrOSLSet();
                MatrixEntryPtrOSLSet(const MatrixEntryPtrOSLSet&);

  Pix           add(MatrixEntryPtr  item);
  void          del(MatrixEntryPtr  item);
  int           contains(MatrixEntryPtr  item);

  void          clear();

  Pix           first();
  void          next(Pix& i);
  MatrixEntryPtr&          operator () (Pix i);
  int           owns(Pix i);
  Pix           seek(MatrixEntryPtr  item);

  void          operator |= (MatrixEntryPtrOSLSet& b);
  void          operator -= (MatrixEntryPtrOSLSet& b);
  void          operator &= (MatrixEntryPtrOSLSet& b);

  int           operator == (MatrixEntryPtrOSLSet& b);
  int           operator != (MatrixEntryPtrOSLSet& b);
  int           operator <= (MatrixEntryPtrOSLSet& b); 

  int           OK();
};


inline MatrixEntryPtrOSLSet::MatrixEntryPtrOSLSet() : p() { count = 0; }

inline MatrixEntryPtrOSLSet::MatrixEntryPtrOSLSet(const MatrixEntryPtrOSLSet& s) : p(s.p) { count = s.count; }

inline Pix MatrixEntryPtrOSLSet::first()
{
  return p.first();
}

inline void MatrixEntryPtrOSLSet::next(Pix  & idx)
{
  p.next(idx);
}

inline MatrixEntryPtr& MatrixEntryPtrOSLSet::operator ()(Pix   idx)
{
  return p(idx);
}

inline void MatrixEntryPtrOSLSet::clear()
{
  count = 0;  p.clear();
}

inline int MatrixEntryPtrOSLSet::contains (MatrixEntryPtr  item)
{
  return seek(item) != 0;
}

inline int MatrixEntryPtrOSLSet::owns (Pix   idx)
{
  return p.owns(idx);
}

inline int MatrixEntryPtrOSLSet::operator != (MatrixEntryPtrOSLSet& b)
{
  return !(*this == b);
}

#endif
